package com.pj.tb_order;

import java.util.List;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.project4sp.SP;

import cn.dev33.satoken.annotation.SaCheckPermission;


/**
 * Controller: tb_order -- 订单表
 * @author loovi
 */
@RestController
@RequestMapping("/TbOrder/")
public class TbOrderController {

	/** 底层 Service 对象 */
	@Autowired
	TbOrderService tbOrderService;


	/** 删 */
	@RequestMapping("delete")
	@SaCheckPermission(TbOrder.PERMISSION_CODE_DEL)
	public AjaxJson delete(Long id){
		 tbOrderService.delete(id);
		return AjaxJson.getSuccess();
	}

	/** 删 - 根据id列表 */
	@RequestMapping("deleteByIds")
	@SaCheckPermission(TbOrder.PERMISSION_CODE_DEL)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(TbOrder.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}

	/** 改 */
	@RequestMapping("update")
	@SaCheckPermission(TbOrder.PERMISSION_CODE_EDIT)
	public AjaxJson update(TbOrder t){
		tbOrderService.update(t);
		return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */
	@RequestMapping("getById")
	@SaCheckPermission(TbOrder.PERMISSION_CODE)
	public AjaxJson getById(Long id){
		TbOrder t = tbOrderService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("getList")
	@SaCheckPermission(TbOrder.PERMISSION_CODE)
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<TbOrder> list = tbOrderService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}


	/** 改 - 删除状态(0=禁用,1=启用) */
	@RequestMapping("updateDeleteStatus")
	@SaCheckPermission(TbOrder.PERMISSION_CODE_EDIT)
	public AjaxJson updateDeleteStatus(Long id, Integer value){
		int line = SP.publicMapper.updateColumnById(TbOrder.TABLE_NAME, "delete_status", value, id);
		return AjaxJson.getByLine(line);
	}



	/*-----           正常业务逻辑👆👆    rpc远程调用👇👇 -----*/

	/** 系统接收到航通接口信息：车辆已出一级市场 ,相对应的一级市场订单状态修改 **/
	@RequestMapping("rpc/orderFinish")
	public boolean orderFinish(@RequestParam("billCode") String billCode) {
		return tbOrderService.orderFinish(billCode);
	}

}
